if (!AjaxTCR.widget)
	AjaxTCR.widget = {};

AjaxTCR.widget.AutoSuggest = {

/* key code constants */
ENTER : 13,
KEYUP : 38,
KEYDOWN : 40,

init : function(url, inputObj, listObj){
											if (typeof(listObj) == "string")
												listObj = document.getElementById(listObj);
											
											if (typeof(inputObj) == "string")
												inputObj = document.getElementById(inputObj);
											
											var payloadParam = inputObj.id; 
												
											if (!inputObj || !listObj)
												return;
												
											var autosuggest = {};
											autosuggest.url = url;
											autosuggest.payloadParam = payloadParam;
											autosuggest.listObj = listObj;
											autosuggest.inputObj = inputObj;
											autosuggest.selectedIndex = -1;
											autosuggest.selectedItem = null;
											
											autosuggest.listObj.style.display = "none";
											autosuggest.listObj.className = "suggestList";
											autosuggest.inputObj.className = "inputObj";
											autosuggest.inputObj.onkeyup = function(e){AjaxTCR.widget.AutoSuggest._checkKey(e, this, autosuggest);};
											autosuggest.inputObj.setAttribute("autocomplete", "off");
 	 										document.onclick = function(e){AjaxTCR.widget.AutoSuggest._checkClick(e, autosuggest);};
										},
										
_checkKey : function(e, obj, autosuggest){
										
										/* get key pressed */
									    var code = (e && e.which) ? e.which : window.event.keyCode;
									    
										/* if up or down move thru the suggestion list */
										if (code == AjaxTCR.widget.AutoSuggest.KEYDOWN || code == AjaxTCR.widget.AutoSuggest.KEYUP)
									    {
									        var index = autosuggest.selectedIndex;
									        if (code ==  AjaxTCR.widget.AutoSuggest.KEYDOWN)
									            index++;
									        else
									            index--;
									
									       /* find item in suggestion list being looked at if any */
									       var selectedItem = document.getElementById("ajaxTCRSuggestList" + index);
									       if (selectedItem)
									       {
												/* set the field to the suggestion */
									           AjaxTCR.widget.AutoSuggest._selectItem(selectedItem, autosuggest);
									           autosuggest.inputObj.value = selectedItem.innerHTML;
									       }
									    }
										else if (code == AjaxTCR.widget.AutoSuggest.ENTER)  /* clear list if enter key */
											AjaxTCR.widget.AutoSuggest._clearList(autosuggest);
									    else if (autosuggest.inputObj == obj) /* otherwise get more suggestions */
									    {
									        autosuggest.selectedIndex = -1;
											autosuggest.selectedItem = null;
									        AjaxTCR.widget.AutoSuggest._getSuggestions(autosuggest);
									    }
									},

_setSuggestion : function(value, autosuggest) {
    									autosuggest.inputObj.value = value;
    									AjaxTCR.widget.AutoSuggest._clearList(autosuggest);
									},

									
_clearList : function(autosuggest){
									autosuggest.listObj.innerHTML = '';
									autosuggest.listObj.style.display = "none";
								 },


_getSuggestions : function(autosuggest){
									var payload = autosuggest.payloadParam + "=" + autosuggest.inputObj.value;
									var options = {method:"GET",
	 											   payload:payload,
	 			    							   onSuccess: AjaxTCR.widget.AutoSuggest._updateSuggestions,
												   autosuggest: autosuggest
				  								  };
				  
									AjaxTCR.comm.sendRequest(autosuggest.url, options);
									},


_updateSuggestions : function(response){
									var autosuggest = response.autosuggest;
								    autosuggest.listObj.innerHTML = "";
										
									var suggestions = AjaxTCR.data.decodeJSON(response.xhr.responseText);
									for(var i=0; i < suggestions.length; i++) 
									{
									  var suggestItem = document.createElement("div");
									  suggestItem.id = "ajaxTCRSuggestList" + i;
									  suggestItem.onmouseover = function(){AjaxTCR.widget.AutoSuggest._selectItem(this, autosuggest);};
									  suggestItem.onmouseout = function(){AjaxTCR.widget.AutoSuggest._unselectItem(this, autosuggest);};
									  suggestItem.onclick = function(){AjaxTCR.widget.AutoSuggest._setSuggestion(this.innerHTML, autosuggest);};
									  suggestItem.className = "suggestLink";
									  suggestItem.appendChild(document.createTextNode(suggestions[i]));
									  autosuggest.listObj.appendChild(suggestItem);
									}
										
									if (suggestions.length > 0)
										autosuggest.listObj.style.display = "";
									else
										autosuggest.listObj.style.display = "none";
	
								},
								

_selectItem : function(selectedItem, autosuggest) {
								    AjaxTCR.widget.AutoSuggest._unselectItem(autosuggest);
									
									autosuggest.selectedItem = selectedItem;
								    selectedItem.className = 'suggestLinkOver';
								    autosuggest.selectedIndex = parseInt(selectedItem.id.substring(18));
								},
								


_unselectItem: function(autosuggest){ 
										if (autosuggest.selectedItem)
										{
											autosuggest.selectedItem.className = 'suggestLink';
											autosuggest.selectedItem = null;
										}
									},
									

_checkClick: function(e, autosuggest){
										var target = ((e && e.target) ||(window && window.event && window.event.srcElement));
									    var tag = target.tagName;
									    if (tag.toLowerCase() != "input" && tag.toLowerCase() != "div")
									    	AjaxTCR.widget.AutoSuggest._clearList(autosuggest);
}




};