<?php

$payload = handleRequest();
sendResponse($payload);


/*********************************  END OF MAIN ****************************/

function handleRequest()
{
	/* Files to write to */
	$RATING_FILE = "ratings.txt";
	$TOTALS_FILE = "totals.txt";


	$expectedPayload = array(array("name"=>"rating", "default"=>0), array("name"=>"comment"), array("name"=>"response", "default"=>"html"), array("name"=>"callback"), array("name"=>"callbackfunction"), array("name"=>"outputTarget"),  array("name"=>"dynamic"), array("name" => "X-Requested-By", "default"=>"downgrade", "rename"=>"transport"));
	$payload = receiveRequest($expectedPayload);	

	/* record the IP address and time */
	$userIP =  $_SERVER['REMOTE_ADDR'];;
	$currentTime = date("M d y h:i:s A");

	/* open the file and get the contents */
	$filehandle = fopen($RATING_FILE, "r");
	if ($filehandle)
	{
	    $data = fread($filehandle, filesize($RATING_FILE));
	    fclose($filehandle);
	}
	else
	   die('Failed to read file ' . $RATING_FILE);


	/* open the file and write line to the top of the file */    
	$filehandle = fopen($RATING_FILE, "w+");
	if ($filehandle) 
	{
	    fwrite($filehandle,$payload["rating"] . "\t ". $payload["transport"] . "\t " .$userIP ." @ " . $currentTime ."\t" . $payload["comment"]. "\n");
	    fwrite($filehandle, $data);
	    fclose($filehandle);
	}
	else
	    die('Failed to write file ' . $RATING_FILE);

	//get the totals
	$payload["votes"] = $payload["total"] = $payload["average"] = 0;
	$filehandle = fopen($TOTALS_FILE, "r+");
	if ($filehandle) 
	{
	    $line = fgets($filehandle, 4096);
	    $tokens = explode("\t", $line);
	
	    if (count($tokens) > 1)
	    {
	        $payload["votes"] = $tokens[0] + 1;
	        $payload["total"] = $tokens[1] + $payload["rating"];
	    }
	
	    fclose($filehandle);
	}
	else
	    die('Failed to read file ' . $TOTALS_FILE);

	$filehandle = fopen($TOTALS_FILE, "w+");
	if ($filehandle) 
	{
	    fwrite($filehandle,$payload["votes"] . "\t" . $payload["total"] . "\n");
	    fclose($filehandle);
	}
	else
	    die('Failed to write file ' . $TOTALS_FILE);
	
	if ($payload["votes"] != 0) $payload["average"] = round(($payload["total"]/$payload["votes"]), 2);
	
	return $payload;
}

function sendResponse($payload)
{

	// send the right headers
	header("Cache-Control: no-cache");
	header("Pragma: no-cache");

	//include template system
	require "smarty.php";
	$smarty->assign('rating', $payload["rating"]);
	$smarty->assign('votes', $payload["votes"]);
	$smarty->assign('average', $payload["average"]);
	
	if (($payload["transport"] == "XHR" && $payload["response"] != "json") || $payload["transport"] == "iframe")
		$smarty->display('rating-Ajax.tpl');
	else if ($payload["transport"] == "downgrade")
		$smarty->display('rating-downgrade.tpl');
	else if ($payload["transport"] == "XHR" && $payload["response"] == "json")
	{
		header("Content-Type: application/json");
	    require_once('JSON.php');
	    $json = new Services_JSON();
	    $jsonResponse = new ResponseData();
	    $jsonResponse->rating = $rating;
	    $jsonResponse->votes = $votes;
	    $jsonResponse->average = $average;
		
		if ($dynamic)
		{
			if ($rating == 4 || $rating == 5)
				$RATING_FILE = "templates/rating-good.tpl";
			else if ($rating == 3)
				$RATING_FILE = "templates/rating-neutral.tpl";
			else
				$RATING_FILE = "templates/rating-bad.tpl";
				
			/* open the file and get the contents */
			$filehandle = fopen($RATING_FILE, "r");
			if ($filehandle)
			{
			    $filedata = fread($filehandle, filesize($RATING_FILE));
			    fclose($filehandle);
			}
			else
			   die('Failed to read file');
					   
			$jsonResponse->templateText = $filedata;
			$jsonResponse->templateURL = $RATING_FILE;
		}
		
	    $message = $json->encode($jsonResponse);	
		print $message;
	}
	else if ($payload["transport"] == "HTMLScriptTag")
	{
		header("Content-Type: application/x-javascript");
		if ($payload["callbackfunction"] != "")
			$message = $payload["callbackfunction"] . "(" . $payload["rating"] . "," . $payload["votes"] . "," .  $payload["average"] . ", '" . $payload["outputTarget"] . "');";
		print $message;	
	}
	else if ($payload["transport"] == "image")
	{
		$results = $payload["rating"] . "_" . $payload["votes"] . "_" . $payload["average"];
	
		//send an image back
		$filename = 'pixel.gif';
		$fp = fopen($filename, 'rb');
		header("Content-Type: image/gif");
		header("Content-Length: " . filesize($filename));
	
		//set the cookie
		setcookie("PollResults", $results, time()+3600, "/", "ajaxref.com");
	
		// dump the response image and end the script
		fpassthru($fp);
		exit;	
	}	
}


/* Helper functions */

function receiveRequest($payload)
{
	$headers = getallheaders();
	$values = array();
	for ($i=0;$i<count($payload);$i++)
	{
		$values[$payload[$i]["name"]] = gpchAndClean($payload[$i], $headers);
		if ($payload[$i]["rename"])
			$values[$payload[$i]["rename"]] = $values[$payload[$i]["name"]];
	}

	
	return $values;
}


function gpchAndClean($payload, $headers)
{
	return htmlentities(substr(urldecode(gpch($payload["name"], strtolower($payload["method"]), $headers, $payload["default"])),0,1024));
}

function gpch($name, $method, $headers, $default)
{
	
    if ((!$method || $method == "get") && isset($_GET[$name]))
		return $_GET[$name];
    else if ((!$method || $method == "post") && isset($_POST[$name]))
		return $_POST[$name];
    else if ( (!$method || $method == "cookie") && isset($_COOKIE[$name]))
		return $_COOKIE[$name];
	else if ((!$method || $method == "headers") && $headers && isset($headers[$name]))
		return $headers[$name];
	else if ((!$method || $method == "headers") && $headers && isset($headers[strtolower($name)]))
		return $headers[strtolower($name)];
	else if ($default)
		return $default;
    else
		return "";
}

class ResponseData
{
    public $average = 0;
    public $rating = 0;
    public $votes = 0;
    public $total = 0;
}


?>