<?php

/* Helper functions */
function gpc($name)
{
    if (isset($_GET[$name]))
	return $_GET[$name];
    else if (isset($_POST[$name]))
	return $_POST[$name];
    else if (isset($_COOKIE[$name]))
	return $_COOKIE[$name];
    else
	return "";
}

class ResponseData
{
    public $average = 0;
    public $rating = 0;
    public $votes = 0;
    public $total = 0;
}


/* File to write to */
$theFile = "ratings.txt";
$totalsFile = "totals.txt";


/* pull the user ratings via request */
$rating = htmlentities(substr(urldecode(gpc("rating")),0,1024));
$comment = htmlentities(substr(urldecode(gpc("comment")),0,1024));
$response = strtolower(htmlentities(substr(urldecode(gpc("response")),0,1024)));
$callback = htmlentities(substr(urldecode(gpc("callback")),0,1024));
if ($rating == "")
    $rating = 0;

/* read transport type */
$headers = getallheaders();
if (isset($headers["X-Requested-By"]) || isset($headers["x-requested-by"]))
	$transport = "XHR";
else if (gpc("X-Requested-By") != "")
	$transport = htmlentities(substr(urldecode(gpc("X-Requested-By")),0,1024));
else
	$transport = "downgrade";
	

/* record the IP address and time */
$userIP =  $_SERVER['REMOTE_ADDR'];;
$currentTime = date("M d y h:i:s A");


/* open the file and get the contents */
$filehandle = fopen($theFile, "r");
if ($filehandle)
{
    $data = fread($filehandle, filesize($theFile));
    fclose($filehandle);
}
else
   die('Failed to read file');


/* open the file and write line to the top of the file */    
$filehandle = fopen($theFile, "w+");
if ($filehandle) 
{
    fwrite($filehandle,"$rating\t $transport\t $userIP @ $currentTime\t $comment\n");
    fwrite($filehandle, $data);
    fclose($filehandle);
}
else
    die('Failed to write file');

/* get the totals */
$votes = $total = $average = 0;
$filehandle = fopen($totalsFile, "r+");
if ($filehandle) 
{
    $line = fgets($filehandle, 4096);
    $tokens = explode("\t", $line);

    if (count($tokens) > 1)
    {
        $votes = $tokens[0] + 1;
        $total = $tokens[1] + $rating;
    }

    fclose($filehandle);
}
else
    die('Failed to read file');

$filehandle = fopen($totalsFile, "w+");
if ($filehandle) 
{
    fwrite($filehandle,"$votes\t$total\n");
    fclose($filehandle);
}
else
    die('Failed to write file');

/* calculate average */
if ($votes != 0) 
  $average = round(($total/$votes), 2);


/* send the result */

// send the right headers
header("Cache-Control: no-cache");
header("Pragma: no-cache");
require('../lib/Smarty/Smarty.class.php');
$smarty = new Smarty();
$smarty->template_dir = './templates';
$smarty->compile_dir = './templates/templates_c';
$smarty->cache_dir = './templates/cache';
$smarty->config_dir = './templates/config';
if ($transport == 'downgrade')
  $smarty->assign('downgradeversion', true);
$smarty->assign('rating', $rating);
$smarty->assign('votes', $votes);
$smarty->assign('average', $average);
$smarty->display('ratingResponse.tpl');

?>
