<?php

/* File to write to */
$theFile = "ratingsui.txt";
$totalsFile = "totalsui.txt";

/* pull the user ratings via the query string */
$rating = htmlentities(substr(urldecode(gpc("uirating")),0,1024));
$comment = htmlentities(substr(urldecode(gpc("comment")),0,1024));
$response = strtolower(htmlentities(substr(urldecode(gpc("response")),0,1024)));
$callback = htmlentities(substr(urldecode(gpc("callback")),0,1024));
$outputTarget = htmlentities(substr(urldecode(gpc("outputTarget")),0,1024));

if ($rating == "")
    $rating = 0;

$headers = getallheaders();
if (isset($headers["X-Requested-By"]) || isset($headers["x-requested-by"]))
	$transport = "XHR";
else if (gpc("X-Requested-By") != "")
	$transport = htmlentities(substr(urldecode(gpc("X-Requested-By")),0,1024));
else
	$transport = "downgrade";
	

if ($response == "")
    $response = "html";


/* record the IP address and time */
$userIP =  $_SERVER['REMOTE_ADDR'];;
$currentTime = date("M d y h:i:s A");

/* open the file and get the contents */
$filehandle = fopen($theFile, "r");
if ($filehandle)
{
    $data = fread($filehandle, filesize($theFile));
    fclose($filehandle);
}
else
   die('Failed to read file');


/* open the file and write line to the top of the file */    
$filehandle = fopen($theFile, "w+");
if ($filehandle) 
{
    fwrite($filehandle,"$rating\t $transport\t $userIP @ $currentTime\t $comment\n");
    fwrite($filehandle, $data);
    fclose($filehandle);
}
else
    die('Failed to write file');

//get the totals
$votes = $total = $average = 0;
$filehandle = fopen($totalsFile, "r+");
if ($filehandle) 
{
    $line = fgets($filehandle, 4096);
    $tokens = explode("\t", $line);

    if (count($tokens) > 1)
    {
        $votes = $tokens[0] + 1;
        $total = $tokens[1] + $rating;
    }

    fclose($filehandle);
}
else
    die('Failed to read file');

$filehandle = fopen($totalsFile, "w+");
if ($filehandle) 
{
    fwrite($filehandle,"$votes\t$total\n");
    fclose($filehandle);
}
else
    die('Failed to write file');

if ($votes != 0) $average = round(($total/$votes), 2);

// send the right headers
header("Cache-Control: no-cache");
header("Pragma: no-cache");
if (($transport == "XHR" && $response != "json") || $transport == "iframe" || $transport == "downgrade")
	$message = "<span id='pollResults'>Thank you for voting.  You rated this a <strong>$rating</strong>.  There are <strong>$votes</strong> total votes.  The average is <strong>$average</strong>.  You can see the ratings in the <a href='http://ajaxref.com/ch9/ratingsui.txt' target='_blank'>ratings file</a></span>";
else if ($transport == "XHR" && $response == "json")
{
	header("Content-Type: application/json");
    require_once('JSON.php');
    $json = new Services_JSON();
    $jsonResponse = new ResponseData();
    $jsonResponse->rating = $rating;
    $jsonResponse->votes = $votes;
    $jsonResponse->average = $average;

    $message = $json->encode($jsonResponse);	
}
else if ($transport == "HTMLScriptTag")
{
	header("Content-Type: application/x-javascript");
	if (gpc("callbackfunction") != "")
		$message = gpc("callbackfunction") . "($rating, $votes, $average, '$outputTarget');";	
}
else if ($transport == "image")
{
	$results = $rating . "_" . $votes . "_" . $average;

	//send an image back
	$filename = 'pixel.gif';
	$fp = fopen($filename, 'rb');
	header("Content-Type: image/gif");
	header("Content-Length: " . filesize($filename));

	//set the cookie
	setcookie("PollResults", $results, time()+3600, "/", "ajaxref.com");

	// dump the response image and end the script
	fpassthru($fp);
	exit;	
}

if ($transport != "downgrade")
{
	echo $message;
	exit;
}


/* Helper functions */
function gpc($name)
{
    if (isset($_GET[$name]))
	return $_GET[$name];
    else if (isset($_POST[$name]))
	return $_POST[$name];
    else if (isset($_COOKIE[$name]))
	return $_COOKIE[$name];
    else
	return "";
}

class ResponseData
{
    public $average = 0;
    public $rating = 0;
    public $votes = 0;
    public $total = 0;
}


?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<title>Voting Results for downgraded version</title>
</head>
<body>
	<h3>If you are not using JavaScript, you will see this downgraded page with results</h3>
<?php echo $message ?>
</body>
</html>
