<?php
require_once "smarty.php";
		
class Widget
{
	static $ratingItems = array();
	
	function getScript()
	{
		global $smarty;
		$smarty->assign('ratingItems',Widget::$ratingItems);
		$output = $smarty->fetch('rating-tag-based-script.tpl');
		return $output;
	}
}

class RatingWidget extends Widget
{
	static $nextid = 0; 
	
    function __construct($options)
	{
		$this->method = "POST";
		$this->min = $this->max = 10;
		$this->url = $this->question = $this->maxstring = $this->minstring = $this->payloadvalue = "abc";
		$this->id = RatingWidget::$nextid;
		RatingWidget::$nextid++;
		
		array_push(Widget::$ratingItems, $this->id);
	
		//set anything passed in	
		foreach ($options as $key=>$value)
			$this->$key = $value;
		
	}
	
	function setMin($val)
	{
		$this->min = $val;
	}
	
	function setMethod($val)
	{
		$this->method = $val;
	}
	
	function setMax($val)
	{
		$this->max = $val;
	}
	
	function setURL($val)
	{
		$this->url = $val;
	}
	
	function setQuestion($val)
	{
		$this->question = $val;
	}
	
	function setMaxString($val)
	{
		$this->maxstring = $val;
	}
	
	function setMinString($val)
	{
		$this->minstring = $val;
	}
	
	function setPayloadValue($val)
	{
		$this->payloadvalue = $val;
	}
	
	
	function get()
	{
		global $smarty;
		$choices = array();
		for ($k=$this->min;$k<=$this->max;$k++)
			array_push($choices, $k);
		
		$smarty->assign('items',$choices);
		$smarty->assign('id', $this->id);
		$smarty->assign('url', $this->url);
		if (isset($this->method))
			$smarty->assign('method', $this->method);
		else
			$smarty->assign('method', "POST");
		
		$smarty->assign('minString', $this->maxstring);
		$smarty->assign('maxString', $this->minstring);
		$smarty->assign('payload', $this->payloadvalue);
		$smarty->assign('question', $this->question);
			
		$output = $smarty->fetch('rating-tag-based-widget.tpl');
		return $output;
	}
	
	

}

?>
