<?php
ob_start("translateOutput");

function translateOutput($output)
{
	/* Search for AjaxTCR:widget tags */
	$ratingItems = array();
	preg_match_all('/\<AjaxTCR:widget([^>]*)\/>/is', $output, $matches, PREG_SET_ORDER);
	for ($i=0; $i < count($matches); $i++) 
	{
		$widgetTag = $matches[$i][0];
	    $allAttributes = $matches[$i][1];
	    $newOutput = $attributes;
		
		preg_match_all('/\s*(\w+)\s*=\s*[\'\"]([^\'\"]+)[\'\"]/is', $allAttributes, $attMatches, PREG_SET_ORDER);
		$attributes = array();
		for($j=0;$j<count($attMatches);$j++)
			$attributes[$attMatches[$j][1]] = $attMatches[$j][2];
			
		$attributes["id"] = $i;
		array_push($ratingItems, $i);
		
		if (strtolower($attributes["name"]) == "rating")
			$newOutput = createRatingWidget($attributes);
		
	    // Replace with actual HTML
	    $output = str_replace($widgetTag, $newOutput, $output);
	}
	
	/* Search for AjaxTCR:includeLib tag */
	preg_match_all('/\<AjaxTCR:includeLib([^>]*)>/is', $output, $matches, PREG_SET_ORDER);
	for ($i=0; $i < count($matches); $i++) 
	{
		$widgetTag = $matches[$i][0];
	    $newOutput = addScript($ratingItems);
	
	    // Replace with actual HTML
	    $output = str_replace($widgetTag, $newOutput, $output);
	}
	
	return $output;
}


function createRatingWidget($attributes)
{
	global $smarty;
	$choices = array();
	for ($k=$attributes["min"];$k<=$attributes["max"];$k++)
		array_push($choices, $k);
	
	$id = $attributes["id"];
	$url = $attributes["url"];
	if (isset($attributes["method"]))
		$method = $attributes["method"];
	else
		$method = "POST";
	$question = $attributes['question'];
	$maxString = $attributes['maxstring'];
	$minString = $attributes['minstring'];
	$payload  = $attributes['payloadvalue'];
	
	
	$output = <<< END_OUTPUT
        <!-- rating widget: BEGIN -->
		<div id="ratingWidget$id">
		<form action="$url" method="$method" id="ratingForm$id" target="_blank">
		
		<div id="question$id">
		 <h3>$question</h3>
		</div>
		
		<em id="minRating$id">$maxString- </em>
		
		<span id="ratings$id"> [
END_OUTPUT;

		for ($k=$attributes["min"];$k<=$attributes["max"];$k++)
		 $output .= "<input type='radio' name='$payload' value='$k' />$k";
		
	$output .= <<< END_OUTPUT
		] </span>
		
		<em id="maxRating$id">- $minString</em>
		
		<br /><br />
		
		<noscript>
		 <input type="hidden" name="transport" value="downgrade" />
		 <input type="submit" value="vote" />
		</noscript>
		
		</form>
		
		<br />
		<div id="ratingResult$id">&nbsp;</div>
		
		</div>
		<!-- rating widget: END -->
END_OUTPUT;
	
	return $output;
	
}

function addScript($ratingItems)
{
	$output = <<< END_OUTPUT
	<script type="text/javascript" src="http://ajaxref.com/ch9/ajaxtcr.js"></script>
	<script type="text/javascript" src="http://ajaxref.com/ch9/ratingprogressive.js"></script>
	<script type="text/javascript">
	AjaxTCR.util.event.addWindowLoadEvent(function () {
END_OUTPUT;

	for ($i=0;$i<count($ratingItems);$i++)
	{
		$output .= "var options = {outputTarget: 'ratingResult$i',form: \$id('ratingForm$i'),ratingContainer : \$id('ratings$i')};\r\n";
        $output .= "AjaxTCR.widget.ratingWidget.init(options);\r\n";
	}
	$output .= "});";
	$output .= "</script>";
	
	return $output;
}


?>